//+------------------------------------------------------------------+
//|                                               FFT_and_Future.mq4 |
//|                                                 Copyright  2008 |
//|                                                m_keeper@mail.ru  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008."
#property link      "m_keeper@mail.ru"
//---
#include <stdlib.mqh>
#define pi 3.14159265358979323846
//---
//#import "#_lib_FFT.ex4"
//void realfastfouriertransform(double& a[], int tnn, bool inversefft);
//#import



//#import "RealFFT.dll" void RealFFT(double& a[], int len, int inversefft);
//#import "RealFFT.dll" int Test(int inversefft);
//#import "tmp3.dll" 
//int my_func(int i);
//#import
//---
#property indicator_separate_window
//indicator_chart_window
//indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DarkOrange
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_width2 1
#property indicator_color3 Red
#property indicator_width3 1
#property indicator_color4 Green
#property indicator_width4 3
#property indicator_color5 Pink
#property indicator_width5 2
#property indicator_color6 DarkSalmon
#property indicator_width6 1
#property indicator_color7 DarkGreen
#property indicator_width7 1
#property indicator_color8 Red
#property indicator_width8 1
//---- buffers
double SpecktrBufferGarm[];
double SpecktrBufferLine[];
double SpecktrBufferG[];
double SpecktrBufferC[];
double SpecktrBufferNEW[];
double SpecktrBufferaa[];
double SpecktrBufferFaz[];
double SpecktrBufferTrend[];
//---

//          
//1)      
//2)  
//     http://codebase.mql4.com/ru/672
//  :
// -  
//- -   
extern int Lenght=560;//  
//extern int Periods=100;//  
extern int Period_count=2;//  
extern int Garmonic=9;//  
extern double GarmonicControl=1.7;
extern int InPast=200;//    ,   
extern int Futur=100;//     
//extern double Gladkost=0;//   -  
extern int iMAperiod=10;//   -  
//    M1-M15

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_LINE);//DRAW_LINE);
SetIndexStyle(1,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexStyle(2,DRAW_HISTOGRAM);//DRAW_HISTOGRAM);
SetIndexStyle(3,DRAW_HISTOGRAM);//DRAW_HISTOGRAM);
SetIndexStyle(4,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexStyle(5,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexStyle(6,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexStyle(7,DRAW_LINE);//DRAW_HISTOGRAM);
SetIndexBuffer(0,SpecktrBufferGarm);
SetIndexBuffer(1,SpecktrBufferLine);
SetIndexBuffer(2,SpecktrBufferG);
SetIndexBuffer(3,SpecktrBufferC);
SetIndexBuffer(4,SpecktrBufferNEW);
SetIndexBuffer(5,SpecktrBufferaa);
SetIndexBuffer(6,SpecktrBufferFaz);
SetIndexBuffer(7,SpecktrBufferTrend);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
double Data(int i)
{
//return(Close[i]);
//return(3.0);
if (iMAperiod<=0)
{
return((Low[i]+High[i])/2);
}
else
{
return(iMA(NULL,0,iMAperiod,0,MODE_SMA,PRICE_MEDIAN,i));
}
}

double Line(double open, double close ,double len,double i)
{
return(close  +(open-close )*(i)/(len-1.0));
}


double LineSKO(double& aa[],double open, double close,int len)
{
double SKO=0;
double tmp;
for(int i=0;i<len;i++)
{
tmp=(aa[i]-Line(open,close,len,i));
SKO+=tmp*tmp;
}
return(SKO);
}


double LineOpenSKO(double& aa[],int len)
{
double maxaa=aa[0];
double minaa=aa[0];
double midaa=aa[0];
double bestaa=aa[0];
double maxsko,minsko,midsko,bestsko;
int i,j,k;
for(i=0;i<len;i++)
{
if(aa[i]>maxaa)maxaa=aa[i];
if(aa[i]<minaa)minaa=aa[i];
}

maxsko=LineSKO(aa,maxaa,aa[0],len);
minsko=LineSKO(aa,minaa,aa[0],len);
bestsko=LineSKO(aa,bestaa,aa[0],len);

for(midaa=minaa;midaa<=maxaa;midaa+=0.001)
{
midsko=LineSKO(aa,midaa,aa[0],len);
if(midsko<bestsko)
{
bestsko=midsko;
bestaa=midaa;
}

}

return(bestaa);
}

int start()
  {

   int i=0;
   int j=0;
   int k=0;
   double aa[];
   double aas[];
   double aac[];
   double aas2[];
   double aac2[];
   double bb[];
   double pow[];
   double faz[];
   double Line[];
   double TopPeriods[];
   double TopGarmonic[];
   double Newaac[];
   double Newaas[];
   int Newlen[];

   double sig;   

   double tmp=0;
   double power=0;
   double amp=0;
   double sdvig=0;
   
   double w,sum_cos,sum_sin,sum;
   
double LocalClose = aa[0];
double LocalOpen = 0;
int LocalLenght =0;
   
   int futur=Futur;
   int N=ArrayResize(aa,Lenght);
   int maxGarmonicPeriod =Lenght/Garmonic;
   int Garmonic_count    =ArrayResize(aac,Lenght-maxGarmonicPeriod+1);
       Garmonic_count	 =ArrayResize(aas,Lenght-maxGarmonicPeriod+1);
       Garmonic_count    =ArrayResize(aac2,Lenght-maxGarmonicPeriod+1);
       Garmonic_count	 =ArrayResize(aas2,Lenght-maxGarmonicPeriod+1);
       N=ArrayResize(bb,Lenght+Futur);
       N=ArrayResize(Line,Lenght+Futur);
     //  Garmonic_count    =ArrayResize(pow,Lenght-maxGarmonicPeriod+1);
       Garmonic_count    =ArrayResize(pow,Lenght-maxGarmonicPeriod+1);
       Garmonic_count    =ArrayResize(faz,Lenght-maxGarmonicPeriod+1);
       Garmonic_count    =ArrayResize(TopPeriods,Lenght-maxGarmonicPeriod+1);
       N=ArrayResize(TopGarmonic,Lenght-maxGarmonicPeriod+1);
 //NewSpector
 int NewLenght=0;
 N = ArrayResize(Newaac,Garmonic*GarmonicControl);
 N = ArrayResize(Newaas,Garmonic*GarmonicControl);
 N = ArrayResize(Newlen,Garmonic*GarmonicControl);
 
   //SetIndexDrawBegin(0,Bars-Lenght-InPast-Futur);
   //SetIndexDrawBegin(1,Bars-InPast+Futur);
   
   
   SetIndexShift(4, -InPast+futur);
   SetIndexShift(5, -InPast);
   SetIndexShift(7, -InPast+futur);
   
   
/*   double openline=Data(Lenght-1+InPast);
   double closeline=Data(InPast);
 //   Alert(DoubleToStr(Close[0], 5));
 //   Alert(DoubleToStr(GetLastError(), 0));
   for(i=0; i<=(Lenght-1+Futur); i++)// ,  
   {
   Line[Lenght-1.0+Futur-i]=openline +(closeline-openline)*(i)/(Lenght-1.0);
   }
*/   
   
double minaa,maxaa;
   for(i=0; i<=Lenght-1; i++)// ,  
   {
      sig=Data(i+InPast);
      if (i==0)
      {
      aa[i]=sig;
      minaa=sig;
      maxaa=sig;
      }else{
      aa[i]=((Lenght-1.0-i)*(sig))/(Lenght-1.0)+aa[i-1]*(0.0+i)/(Lenght-1.0);
      if(aa[i]>maxaa){maxaa=aa[i];}
      if(aa[i]<minaa){minaa=aa[i];}
      }
   }
   
//   for(i=0; i<=Lenght-1; i++)// ,  
//   {
//   aa[i]-=Line[i+Futur];
//   }
//*/

   //    -      aa[] - 
 //RealFFT(aa, tnn1, 1); 
 //  realfastfouriertransform(aa, tnn1, false); 

   






//maxGarmonicPeriod 
//Period_count

for (k=0; k<Garmonic_count; k++)
{ 
      sum_cos=0.0; 
      sum_sin=0.0;  
      LocalLenght = Lenght-k;
      LocalOpen = aa[LocalLenght-1];
      w=Period_count*2*pi/LocalLenght ;                                    
      for (int nn=0; nn<LocalLenght ; nn++) 
      {
         tmp=aa[nn]-Line(LocalOpen ,LocalClose ,LocalLenght ,nn);
         sum_cos+=tmp*MathCos(nn*w); 
         sum_sin+=tmp*MathSin(nn*w);
      }
      aac[k]=sum_cos*2/LocalLenght; 
      aas[k]=sum_sin*2/LocalLenght;
    //  aac2[k]=sum_cos*2/Lenght; 
    //  aas2[k]=sum_sin*2/Lenght;
}
//aac[0]=aac[0]/2;

for( i=0; i<Garmonic_count; i++)
{
      if(aac[i]<0){sdvig=pi;}else{sdvig=0;}
      faz[i]=MathArctan(aas[i]/aac[i])+sdvig; 
      tmp=MathSqrt(aac[i]*aac[i]+aas[i]*aas[i]); 
      pow[i]=tmp;
      if(tmp>power)power=tmp;
}

/*
for (nn=0; nn<= Lenght-1; nn++)
{
      sum=0.0;
      LocalLenght = Lenght-k;
      LocalOpen = aa[LocalLenght-1];
      w=Period_count*2*pi/LocalLenght ; 
      for (k=0; k<=Garmonic_count; k++)
      {                                                             
         sum+=aac[k]*MathCos(nn*w)+aas[k]*MathSin(nn*w);
      }                                                             
      bb[nn]=sum+Line(LocalOpen ,LocalClose ,LocalLenght ,nn);
}
*/

int LocalPeriod1=0;
int LocalPeriod2=0;
int LastPos=0;
int LocalMax=0;
//double mnojitel=GarmonicControl;//Period_count;
int LocalGarmonic=Garmonic*GarmonicControl;
bool gomax=true;

//Alert("OK1");
for( i=1; i<LocalGarmonic; i++)
{
   //   tmp=MathSqrt(aac[i]*aac[i]+aas[i]*aas[i]); 
   LocalPeriod1=Lenght-(Lenght*GarmonicControl)/(i);
   LocalPeriod2=Lenght-(Lenght*GarmonicControl)/(i+1);
   LocalMax=LocalPeriod1;
   for(k=LocalPeriod1;k<=LocalPeriod2;k++)
   {
      if(pow[k]>pow[LocalMax])LocalMax=k;
      SpecktrBufferC[k]=0;
      SpecktrBufferG[k]=0;
   }
   //Alert(DoubleToStr(LocalPeriod, 5));
      //if(tmp>power)power=tmp;
bool addme=false;
if((gomax==true)&&(LocalMax<=LocalPeriod1+3)){addme=true;gomax=false;}else
if((gomax==true)&&(LocalMax>=LocalPeriod2-3)){addme=false;gomax=true;}else
if((gomax==false)&&(LocalMax<=LocalPeriod1+3)){addme=false;gomax=false;}else
if((gomax==false)&&(LocalMax>=LocalPeriod2-3)){addme=false;gomax=true;}

      SpecktrBufferG[LocalPeriod1]=Lenght-LocalPeriod1;
      
if((LocalMax>LocalPeriod1)&&(LocalMax<LocalPeriod2)){addme=true;gomax=false;}

if(addme)
{
      SpecktrBufferC[LocalMax]=pow[LocalMax]/power*Lenght;
      Newaac[NewLenght]=aac[LocalMax];
      Newaas[NewLenght]=aas[LocalMax];
      Newlen[NewLenght]=Lenght-LocalMax;
   NewLenght++;   
}
}
//SpecktrBufferNEW


//LocalLenght = Lenght-k;
LocalOpen = LineOpenSKO(aa,Lenght);//aa[Lenght-1];
double minbb,maxbb;
double ves=0;
for (nn=-Futur; nn<= Lenght-1; nn++)
{
      sum=0.0;
     // Alert(DoubleToStr(Newlen[0], 0));
      for (k=0; k<NewLenght; k++)//NewLenght
      {                          
      w=2*pi*Period_count/Newlen[k] ;                              
      if(nn<=Newlen[k]){ves=1;}else                   //*Period_count
      if(nn<=2*Newlen[k]){ves=(2.0*Newlen[k]-nn)/(Newlen[k]);}else{ves=0;}
         sum+=ves*(Newaac[k]*MathCos(nn*w)+Newaas[k]*MathSin(nn*w));
      }                                                             
      //bb[nn+Futur]=sum+Line(LocalOpen ,LocalClose ,Lenght ,nn);    
      bb[nn+Futur]=sum+Line(LocalOpen ,LocalClose ,Lenght ,nn);
      if(nn==-Futur){minbb=bb[nn+Futur];maxbb=bb[nn+Futur];}
      if(bb[nn+Futur]>maxbb){maxbb=bb[nn+Futur];}
      if(bb[nn+Futur]<minbb){minbb=bb[nn+Futur];}
}




for (nn=0; nn<= Lenght-1; nn++)
{
      SpecktrBufferaa[nn]=(aa[nn]-minaa)/(maxaa-minaa)*Lenght;
}

for (nn=0; nn<= Lenght-1+Futur; nn++)
{
      SpecktrBufferTrend[nn] =(Line(LocalOpen ,LocalClose ,Lenght ,nn-Futur)-minaa)/(maxaa-minaa)*Lenght;
      SpecktrBufferNEW[nn]=(bb[nn]-minaa)/(maxaa-minaa)*Lenght;//-minbb)/(maxbb-minbb)*Lenght;
}

for( i=0; i<Garmonic_count; i++)//Lenght+Futur-1
{
      SpecktrBufferGarm[i]=pow[i]/power*Lenght;//*100000.0;
      SpecktrBufferFaz[i]=((faz[i]+pi/2.0)/(2.0*pi))*Lenght;
      SpecktrBufferLine[i]=(Lenght-i+0.0);
}


  // Alert(DoubleToStr(NewLenght, 0));
/*
   w=2*pi/Lenght;

//for (int k=0; k<=Garmonic; k++)
   {                                                              
      sum_cos=0.0; 
      sum_sin=0.0;                                           
      for (int nn=0; nn<Lenght; nn++) 
      {
         sum_cos+=aa[nn]*MathCos(k*nn*w); 
         sum_sin+=aa[nn]*MathSin(k*nn*w);
      }
      aac[k]=sum_cos*2/Lenght; 
      aas[k]=sum_sin*2/Lenght;
   }
   aac[0]=aac[0]/2;
   //------------------------------------
   for (nn=Lenght+Futur-1; nn>= 0; nn--)
   {                                                        
      sum=0.0;                                       
      for (k=0; k<=Garmonic; k++)
      {                                                             
         sum+=aac[k]*MathCos(k*nn*w)+aas[k]*MathSin(k*nn*w);
      }                                                             
      bb[nn]=sum;
   }

   //*/
/*
for( i=1; i<N/2; i++)
   {
      tmp=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      pow[i]=tmp;
      if(tmp>power)power=tmp;
   } //*/
/*   
double period=0;
for( i=1; i<N/2; i++)//     
   {
      period=(N+0.0)/(i+0.0);
      amp=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      amp=amp*MathPow(amp/power,Gladkost);
      double sdvig;
      double pravo;
      if(aa[i*2]>0){pravo=1;}else{pravo=0;}
      if((pravo==0)){sdvig=pi;}else{sdvig=0;}
      faz=MathArctan(aa[i*2+1]/aa[i*2])+(futur+iMAperiod/2)*2*pi/period+sdvig; 
      aa[i*2]=amp*MathCos(faz);
      aa[i*2+1]=amp*MathSin(faz);
   }
   */
   
   
 /*for( i=1; i<N/2; i++)
   {
      power+=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
   }
   double porog=power*Porog;
 for( i=1; i<N/2; i++)//  
   {
      //   
      tmp=MathSqrt(aa[i*2]*aa[i*2]+aa[i*2+1]*aa[i*2+1]); 
      if(tmp<porog)
      {
      aa[i*2]=0;
      aa[i*2+1]=0;
      }
   }//*/


   
   
 //  RealFFT(aa, tnn1, -1);//    
 //  realfastfouriertransform(aa, tnn1, true);//    
//   for( i=0; i<Garmonic_count-1; i++)//Lenght+Futur-1
//   {
  // bb[i]=aa[i];
//      SpecktrBufferGarm[i]=pow[i]/power*Lenght;//*100000.0;
//      SpecktrBufferLine[i]=(Lenght-i+0.0);
    
    //  SpecktrBufferGarm[i]=bb[i]+Line[i];
    //  SpecktrBufferLine[i]=aa[i];
//   }
//Alert("OK");
   return(0);
  }
  
//+------------------------------------------------------------------+

//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])// ,  
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}
//---------------------------------------------------------------------+